// scripted by Rassadin Pavel (RPV); e-mail: mf36@yandex.ru; data: 16.06.2006; freeware;
#include "/C/Program Files/Adobe/Adobe Illustrator CS2/Presets/Scripts/MarX/MarX.ini"
doc = activeDocument;
origin = doc.rulerOrigin;
var start = true;
var obj = doc.selection[0];
var obj1 = doc.selection;

if ( obj1.length > 0 ) {	
	
	if (of = prompt(offsetStr, defStr)){
		param = of.split(' ');
		markOffset = param[0] *mm;
		bleedOffset = param[1] *mm;
		newLayer = param[2];
		regColor = newCMYKcolor(100,0,0,0);
		if (param[2]=='c') regColor = newCMYKcolor(100,0,0,0);			
		if (param[2]=='m') regColor = newCMYKcolor(0,100,0,0);
		if (param[2]=='y') regColor = newCMYKcolor(0,0,100,0);
		if (param[2]=='k') regColor = newCMYKcolor(0,0,0,100);
		if (param[2]=='r'){
			var regColor = new SpotColor();
			regColor.spot = doc.spots['[Registration]'];
		}			
	}
	else start = false;
	if (start){					
		var bnd = getBounds(obj1);
		x1 = bnd[0];
		x2 = bnd[2];
		y1 = bnd[1];
		y2 = bnd[3];
		W = x2-x1;
		H = y1-y2;
		xN = Math.floor(doc.width/W);
		yN = Math.floor(doc.height/H);
		delLayer('MarX');
		var mLayer= doc.layers.add();
		mLayer.name = 'MarX';
	if (doc.selection instanceof Array && doc.selection.length==1) {			
		if (confirm(distribStr)) {
			ox = ((doc.width-(W*xN))/2)-origin[0]+(obj.left - x1);
			oy = ((doc.height-(H*yN))/2)-origin[1]+(obj.top - y1);
			for(i=0; i<xN; i++) 
				for(j=1; j<=yN; j++) {
					objCopy = obj.duplicate(obj.parent);
					objCopy.left = ox+i*W;
					objCopy.top = oy+j*H;
				}
			obj.remove();						
			TrimMarX (mLayer,W,H,xN,yN,bleedOffset,markOffset,markLength,markWeight,regColor);
		}
		else TrimMarX2 (mLayer,x1,y1,x2,y2,regColor,markWeight,markOffset,bleedOffset);		
	}
	else {		
		var mLayer3= mLayer.layers.add();    	 
		mLayer3.name = 'trimMarX';
		var mLayer2= mLayer.layers.add();    	 
		mLayer2.name = 'rectMarX';
		for(i=0; i<obj1.length; i++){
			if( (obj1[i].typename == 'GroupItem') && obj1[i].clipped && (obj1[i].pageItems.length > 1) ) bnd = obj1[i].pathItems[0].geometricBounds;
			else bnd = obj1[i].geometricBounds;
			x1 = bnd[0];
			x2 = bnd[2];
			y1 = bnd[1];
			y2 = bnd[3];
			rectDef (mLayer2,x1,y1,x2,y2,newCMYKcolor(0,0,0,0));
			TrimMarX2 (mLayer3,x1,y1,x2,y2,regColor,markWeight,markOffset,bleedOffset);
		}	
	}
	mLayer.zOrder(ZOrderMethod.SENDTOBACK);	
	}
}
else {
	alert(errorStr,'MarX',true);	
}

function newCMYKcolor(c,m,y,k){
	var regColor = new CMYKColor();
	regColor.cyan = c;
	regColor.magenta = m;
	regColor.yellow = y;
	regColor.black = k;
	return regColor;
}

function line(parent,x1,y1,x2,y2,color,weight){
	var line = parent.pathItems.add();
	line.stroked = true;
	line.filled = false;
	line.strokeWidth = weight;
	line.strokeColor = color;
	line.setEntirePath( Array( Array(x1, y1), Array(x2, y2) ) );
	line = null;
}

function getBounds(obj){	
	var vgb1 = new Array();
	var vgb2 = new Array();
	var n = obj.length;
	if (n>0){		
		if( (obj[0].typename == 'GroupItem') && obj[0].clipped && (obj[0].pageItems.length > 1) ) vgb1 = obj[0].pathItems[0].geometricBounds;
		else vgb1 = obj[0].geometricBounds;
		if (n > 1) {
			for (i=1; i<n; i++) {				
				if( (obj[i].typename == 'GroupItem') && obj[i].clipped && (obj[i].pageItems.length > 1) ) {
					vgb2 = obj[i].pathItems[0].geometricBounds;
				}		
				else {
					vgb2 = obj[i].geometricBounds;
				}
				if( vgb1[0] > vgb2[0] ) vgb1[0] = vgb2[0];
				if( vgb1[1] < vgb2[1] ) vgb1[1] = vgb2[1];
				if( vgb1[2] < vgb2[2] ) vgb1[2] = vgb2[2];
				if( vgb1[3] > vgb2[3] ) vgb1[3] = vgb2[3];
			}
		}
	}
	return vgb1;
}

function TrimMarX (mLayer,W,H,xN,yN,bleedOffset,markOffset,markLength,markWeight,regColor){
	tW = W*xN;
	tH = H*yN;
	oX = ((doc.width-tW)/2)-origin[0];
	oY = ((doc.height-tH)/2)-origin[1];	
	if (bleedOffset>0) {
		for(i=0; i<xN; i++) {
			line(mLayer, oX+W*i+bleedOffset, oY-markOffset, oX+W*i+bleedOffset, oY-markOffset-markLength, regColor, markWeight);
			line(mLayer, oX+W*i+W-bleedOffset, oY-markOffset, oX+W*i+W-bleedOffset, oY-markOffset-markLength, regColor, markWeight);
			line(mLayer, oX+W*i+bleedOffset, oY+tH+markOffset, oX+W*i+bleedOffset, oY+tH+markOffset+markLength, regColor, markWeight);
			line(mLayer, oX+W*i+W-bleedOffset, oY+tH+markOffset, oX+W*i+W-bleedOffset, oY+tH+markOffset+markLength, regColor, markWeight);
		}
		for(i=0; i<yN; i++) {
			line(mLayer, oX-markOffset, oY+H*i+bleedOffset, oX-markOffset-markLength, oY+H*i+bleedOffset, regColor, markWeight);
			line(mLayer, oX-markOffset, oY+H*i+H-bleedOffset, oX-markOffset-markLength, oY+H*i+H-bleedOffset, regColor, markWeight);
			line(mLayer, oX+tW+markOffset, oY+H*i+bleedOffset, oX+tW+markOffset+markLength, oY+H*i+bleedOffset, regColor, markWeight);
			line(mLayer, oX+tW+markOffset, oY+H*i+H-bleedOffset, oX+tW+markOffset+markLength, oY+H*i+H-bleedOffset, regColor, markWeight);
		}
	}
	else {
		for(i=0; i<=xN; i++) {
			line(mLayer, oX+W*i, oY-markOffset, oX+W*i, oY-markOffset-markLength, regColor, markWeight);
			line(mLayer, oX+W*i, oY+tH+markOffset, oX+W*i, oY+tH+markOffset+markLength, regColor, markWeight);
		}
		for(i=0; i<=yN; i++) {
			line(mLayer, oX-markOffset, oY+H*i, oX-markOffset-markLength, oY+H*i, regColor, markWeight);
			line(mLayer, oX+tW+markOffset, oY+H*i, oX+tW+markOffset+markLength, oY+H*i, regColor, markWeight);
		}
	}	
}

function TrimMarX2 (mLayer,x1,y1,x2,y2,regColor,markWeight,markOffset,bleedOffset){
	line(mLayer,x1+bleedOffset,y1+markOffset,x1+bleedOffset,y1+markOffset+markLength,regColor,markWeight);
	line(mLayer,x2-bleedOffset,y1+markOffset,x2-bleedOffset,y1+markOffset+markLength,regColor,markWeight);
	line(mLayer,x1+bleedOffset,y2-markOffset,x1+bleedOffset,y2-markOffset-markLength,regColor,markWeight);
	line(mLayer,x2-bleedOffset,y2-markOffset,x2-bleedOffset,y2-markOffset-markLength,regColor,markWeight);
	line(mLayer,x1-markOffset-markLength,y1-bleedOffset,x1-markOffset,y1-bleedOffset,regColor,markWeight);
	line(mLayer,x2+markOffset+markLength,y1-bleedOffset,x2+markOffset,y1-bleedOffset,regColor,markWeight);
	line(mLayer,x1-markOffset-markLength,y2+bleedOffset,x1-markOffset,y2+bleedOffset,regColor,markWeight);
	line(mLayer,x2+markOffset+markLength,y2+bleedOffset,x2+markOffset,y2+bleedOffset,regColor,markWeight);
}

function rectDef (mLayer,x1,y1,x2,y2,strColor){
	mLayer.locked = false;
	var rect = mLayer.pathItems.rectangle (y1, x1, x2-x1, y1-y2);
	rect.fillColor = strColor;
	rect.stroked = false;
	mLayer.locked = true;
}

function delLayer(layerName){
	for (i=0; i<doc.layers.length; i++){
		param = doc.layers[i].name.split(' ');			
		for (j=0; j<param.length; j++)
			if ((param[j] == layerName)&&(doc.layers[i].locked == false)){
				doc.layers[i].remove();
				i-=1;
			}
	}
}